package demo;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;


public class foodItem extends JLabel
{
    private String foodName;         //name of food
    private boolean insideFridge;    //whether item is in fridge or out
    private int rmTime;	             //time item was removed from the fridge
    private int itemNo;	             //the tag's number

    private int creationTime;        //time it was added to the database
    private int tolerance;           //how tolerant the item is to being left out
    private int expTime;             //when the item will expire
    private String removalPerson;    //person to take item out of fridge
    private boolean fridgeBfrOpen;	//whether the item is supposed to be fridged before it is opened	
						//so whether there is an absolute or relative exp. date
    //private RFIDTag thisTag;

    /*
      Info stored on RFID tags by manufacterer
      manufactured date
      name of product
      manufacterer's expected expiration date
      tolerance to warmth (out of fridge)

      Added by software: whether it is in the database
      exp date change if any

      eventually the software will add a removed from the fridge time so that
      it doesn't need to be kept in a database, but right now w/ only one RFID
      reader that isn't an option.
    */

    public foodItem(String thisname, long RFIDNo)
    {
	super(thisname);
	
	if(RFIDNo != 0)
	{	
		long tmp;
		foodName = thisname;
		insideFridge = true;
      	tmp = RFIDNo & 0x00000000FFFFFFFF;
		itemNo = (int)tmp;
		rmTime = 0;
	}
	else
	{
		foodName = "PlaceHolder";
		itemNo = 0;
		rmTime = 0;
	}

    }

	public void changeItem(String thisname, long RFIDNo)
	{
		long tmp;
		foodName = thisname;
		insideFridge = true;
      	tmp = RFIDNo & 0x00000000FFFFFFFF;
		itemNo = (int)tmp;
		rmTime = 0;
		super.setText(foodName);
	}

    public String getName()
	{
		return(foodName);
	}

	public void itemRemoved()
	{
		insideFridge = false;
		System.out.println(foodName + " was removed");
		//set the parent's text field to empty
		super.setText("Removed: " + foodName);
	}
	
	public void itemAdded()
	{
		insideFridge = true;
		System.out.println(foodName + " was returned");
		//set parent's text field back to the item
		super.setText(foodName);
	}

	public int getID()
	{
		return(itemNo);
	}

	public boolean isInFr()
	{
		return(insideFridge);
	}

	public boolean isMe(long RFIDNo)
	{
		int askedRFID;
		long tmp;
      	tmp = RFIDNo & 0x00000000FFFFFFFF;
		askedRFID = (int)tmp;
		//returns whether or not a given ID No is this particular RFID Tag
		if(askedRFID == itemNo)
			return true;
		else
			return false;
	}

}
