//javac -classpath . main.java
package demo;

import rfid.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;

public class main extends JFrame implements RFIDListener
{
    protected static foodItem [] fritems;
    protected JLabel [] outItems;
    private static RFIDReader theFridge;
    private static int noOutItems;
    private static int inItems;			//actually total number of items
    private RFIDTag [] curItems;
    private static JPanel itemsList;
    private static Container content;
    private static JLabel MsgPanel;

    public static void main(String [] args) throws Exception
    {
	new main();
    }
    
    public main() throws Exception
    {

	//initialize RFID reader
	//get list of all tags currently within range of the RFID reader
	//stick them in the array and put them on screen
	//set up the RFID reader
        theFridge = new RFIDReader("COM2");
	theFridge.addRFIDListener(this);

	//theFridge.reset();
	curItems = theFridge.inventory();
	theFridge.reset();
	System.out.println("I started with " + curItems.length);	

	//System.out.println("Calling setUPItems().");
	//setupItems();

	//JLabel[] fritems = new JLabel[6];
	fritems = new foodItem[6];
	inItems = curItems.length;

	setLocation(0,0);
	setSize(400,750);
	setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	//make the window
       	content = getContentPane();
	content.setLayout(new BorderLayout());
	
	//label the top of the window
	JLabel progName = new JLabel("Smart Fridge");
	progName.setBorder(new LineBorder(Color.black, 2));
	content.add(progName, BorderLayout.NORTH);
	progName.setFont(new Font("Arial", Font.BOLD, 20));
       
	//make a section for itemlists
	itemsList = new JPanel();
	itemsList.setBorder(new LineBorder(Color.blue, 2));
	itemsList.setLayout(new GridLayout(6,1));

	
	//add items to the list on the left hand side
	//based on the current items in the fridge
	//they will display info on the item when it is moused over
	JLabel item1 = new JLabel("Items Inside Fridge");
	item1.setBorder(new LineBorder(Color.black, 2));
	itemsList.add(item1);
	item1.setFont(new Font("Arial", Font.BOLD, 14));

	for(int i = 0; i < curItems.length; i++)
	{
		theFridge.reset();
		fritems[i] = new foodItem(curItems[i].readDataFromTag(), curItems[i].getRFID());
		itemsList.add(fritems[i]);
	}
	//number the available but unused slots
	for(int i = curItems.length; i < 6; i++)
	{
		fritems[i] = new foodItem(i + ": ", 0);
		itemsList.add(fritems[i]);
	}

	content.add(itemsList, BorderLayout.CENTER);
	JLabel messages = new JLabel("Messages from Fridge:");
	messages.setBorder(new LineBorder(Color.black, 2));
	content.add(messages, BorderLayout.SOUTH);
	MsgPanel = messages;
	messages.setFont(new Font("Arial", Font.BOLD, 18));
	show();
    }


	public void setupItems() throws Exception
	{
		long tmp;

		System.out.println("In setUpItems().");
		System.out.println("# of curItems: " + curItems.length);
		for(int i = 0 ; i < curItems.length; i++)
		{
                   tmp = curItems[i].getRFID() & 0x00000000FFFFFFFF;
		   int shortItemNo = (int) tmp;

		   if(shortItemNo == 0x184CEABC)
		   { 
			curItems[i].setData("Orange Juice");
			curItems[i].writeDataToTag();
			System.out.println("Found OJ (in the Ford Bronco).");	
		   }
		   else if(shortItemNo == 0x184CEAB4)
		   { 
			curItems[i].setData("Yogurt      ");
			curItems[i].writeDataToTag();
			System.out.println("Found Yogurt.");
		   }
		   else if(shortItemNo == 0x184CEAB8)
		   { 
			curItems[i].setData("Milk        ");
			curItems[i].writeDataToTag();
			System.out.println("Found Milk.");
		   }
		   else if(shortItemNo == 0x184CEABD)
		   { 
			curItems[i].setData("Apple Juice ");
			curItems[i].writeDataToTag();
		   	System.out.println("Found Apple Juice.");
		   }
		   else 
		   { 
			System.out.println("Found something else.");
			System.out.println("and that is..." + shortItemNo);
			curItems[i].setData("nothing");
			curItems[i].writeDataToTag();
		   }
		}
	}


	public void tagRemoved(RFIDTag tag)
	{
		long nameNo;
		String name = "All Gone";
		try{
			nameNo = tag.getRFID();
		}catch(Exception e){
			nameNo = 0x0;
			name = "gone";
		}
		//repaint();

		//figure out which fridge item it is:
		for(int i = 0; i < inItems; i++)
		{
			if(fritems[i].isMe(nameNo))
			{
				//if correct tag, tell it that it has been removed
				fritems[i].itemRemoved();
				System.out.println("Tag removed is: " + fritems[i].getName());
				name = fritems[i].getName();
			}
		}
		if(MsgPanel != null)
		{
			MsgPanel.setText("Removed: " + name);				
		}
		itemsList.repaint();
	}

	public void tagAdded(RFIDTag tag)
	{
		boolean exist = false;
		String name = "initial";
		long nameNo;
		try{
			name = tag.readDataFromTag();
			nameNo = tag.getRFID();

		}catch(Exception e)
		{
			System.out.println("Stupid Tag");
			nameNo = 0x0;
		}
		System.out.println("Item returned to me! " + name);

		//some times throws a null pointer exception because the RFID reader will register
		//added tags before the interface has been created
		if(fritems!= null)
		{
			//if item already exists, modify label, otherwise make a new one
			//figure out which fridge item it is:
			for(int i = 0; i < inItems; i++)
			{
				if(fritems[i].isMe(nameNo))
				{
					//if correct tag, tell it that it has been added again
					fritems[i].itemAdded();
					System.out.println("Tag re-added is: " + fritems[i].getName());
					exist = true;
					if(MsgPanel != null)
					{
						MsgPanel.setText("Added: " + name);
					}

				}
			}
			if((!exist)&& (name != "initial"))
			{
				//move to the next empty spot
				System.out.println("New Item: " + name);
				//inItems++;
				fritems[inItems].changeItem(name, nameNo);
				if(MsgPanel != null)
				{
					MsgPanel.setText("Added New: " + name);
				}
				inItems++;
			}
			
		}
		if(itemsList !=null)
		{
			itemsList.repaint();
			repaint();
		}
	}
}
