/*
 * @(#) RFIDListener.java
 * 
 * RFID Tag Reader API
 * COMP150-TUI: Tangible User Interfaces
 * Tufts University, Department of Computer Science
 */
package rfid;

/**
 * Classes that implement this interface can be notified when RFID
 * tags enter and exit the RFID reader's "field of vision".
 *
 * @author Michael Horn
 * @version $Revision$, $Date$
 */
public interface RFIDListener {

/**
 * Invoked when an RFID tag first becomes visible to the reader.
 */
   public void tagAdded(RFIDTag tag);

/**
 * Invoked when a visible tag is removed from the reader.
 */
   public void tagRemoved(RFIDTag tag);

}

